﻿Imports NetHIDLibrary.HidControl
Public Class Form1


    Const lm35vref As Double = 1800 'mV
    Const lm35res As Double = 10 '10mV/C
    Const max12bit As Double = 4095

    Dim outputBuffer() As Byte

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Me.HidControl1.VendorID = &H1234
        Me.HidControl1.ProductID = &H1
        HidControl1.UseControlTransferOnly = False
    End Sub

    Private Sub HidControl1_OnCloseCommunications(sender As Object, msg As String) Handles HidControl1.OnCloseCommunications
        Me.TextBox1.AppendText("Communication closed at: " & Now().ToShortTimeString & vbCrLf & _
                               " Error Message: " & msg & vbCrLf)
    End Sub

    Private Sub HidControl1_OnDataReceived(sender As Object, data() As Byte) Handles HidControl1.OnDataReceived
        'Me.TextBox1.AppendText("Data received at: " & Now().ToShortTimeString & " Data length: " & data.Length.ToString & vbCrLf)
        Dim tmp As UInt16

        tmp = data(1) And &HFF
        tmp = (tmp << 8) + data(2)
        Me.dsValue.Text = getTempFromDS1820(tmp).ToString("00.000")

        tmp = data(3) And &HFF
        tmp = (tmp << 8) + data(4)
        Me.lmValue.Text = getTempFromLM35(tmp).ToString("00.000")

        tmp = data(5) And &HFF
        tmp = (tmp << 8) + data(6)
        Me.adcValue.Text = tmp.ToString
        'Application.DoEvents()
        'Me.TextBox1.AppendText(data(4).ToString("X2") & data(5).ToString("X2") & vbCrLf)
    End Sub

    Private Sub HidControl1_OnDeviceAttached(sender As Object, e As NetHIDLibrary.DeviceAttributes) Handles HidControl1.OnDeviceAttached

        Me.tmrContinuousDataCollect.Start()

        Me.Label1.Text = "Device attached"

    End Sub


    Private Sub HidControl1_OnDeviceDetected(sender As Object, e As NetHIDLibrary.DeviceAttributes) Handles HidControl1.OnDeviceDetected
        Me.Label1.Text = "Device detected"
        With TextBox1
            '.Clear()
            .AppendText("**********************************************************" & vbCrLf)
            .AppendText("Device connected at: " & Now().ToShortTimeString & vbCrLf)
            .AppendText("**********************************************************" & vbCrLf)
            .AppendText("Vendor ID: " & e.VENDOR_ID.ToString & vbCrLf)
            .AppendText("Product ID: " & e.PRODUCT_ID.ToString & vbCrLf)
            .AppendText("Version number: " & e.VERSION_NUMBER.ToString & vbCrLf)
            .AppendText("Structure size: " & e.STRUCTURE_SIZE.ToString & vbCrLf)
            .AppendText("Feature report byte length: " & e.FEATURE_REPORT_BYTE_LENGTH.ToString & vbCrLf)
            .AppendText("Input report byte length: " & e.INPUT_REPORT_BYTE_LENGTH.ToString & vbCrLf)
            .AppendText("Number feature button caps: " & e.NUMBER_FEATURE_BUTTON_CAPS.ToString & vbCrLf)
            .AppendText("Number feature data indices: " & e.NUMBER_FEATURE_DATA_INDICES.ToString & vbCrLf)
            .AppendText("Number feature value caps: " & e.NUMBER_FEATURE_VALUE_CAPS.ToString & vbCrLf)
            .AppendText("Number input button caps: " & e.NUMBER_INPUT_BUTTON_CAPS.ToString & vbCrLf)
            .AppendText("Number input data indices: " & e.NUMBER_INPUT_DATA_INDICES.ToString & vbCrLf)
            .AppendText("Number input value caps: " & e.NUMBER_INPUT_VALUE_CAPS.ToString & vbCrLf)
            .AppendText("Number link collection nodes: " & e.NUMBER_LINK_COLLECTION_NODES.ToString & vbCrLf)
            .AppendText("Number output button caps: " & e.NUMBER_OUTPUT_BUTTON_CAPS.ToString & vbCrLf)
            .AppendText("Number output data indices: " & e.NUMBER_OUTPUT_DATA_INDICES.ToString & vbCrLf)
            .AppendText("Number output value caps: " & e.NUMBER_OUTPUT_VALUE_CAPS.ToString & vbCrLf)
            .AppendText("Output report byte length: " & e.OUTPUT_REPORT_BYTE_LENGTH.ToString & vbCrLf)
            .AppendText("Usage: " & e.USAGE.ToString & vbCrLf)
            .AppendText("Usage page: " & e.USAGE_PAGE.ToString & vbCrLf)
        End With
        Array.Resize(Me.outputBuffer, e.NUMBER_INPUT_DATA_INDICES)
        tmrContinuousDataCollect.Enabled = True
        tmrContinuousDataCollect.Start()
    End Sub

    Private Sub HidControl1_OnDeviceRemoved(sender As Object, e As NetHIDLibrary.DeviceAttributes) Handles HidControl1.OnDeviceRemoved
        tmrContinuousDataCollect.Stop()
        Me.Label1.Text = "Device removed"
    End Sub

    Private Sub tmrContinuousDataCollect_Tick(sender As Object, e As EventArgs) Handles tmrContinuousDataCollect.Tick
        'Me.outputBuffer(0) = 0 'This byte always has the value=0
        Me.outputBuffer(1) = &HFF 'your values 
        HidControl1.ReadAndWriteToDevice(Me.outputBuffer)
    End Sub

    Private Function getTempFromLM35(ByVal Value As UInt16) As Double
        Return CDbl(Value) * lm35vref / max12bit / lm35res
    End Function

    Private Function getTempFromDS1820(ByVal Value As UInt16) As Double
        Dim a, b As Double
        a = CDbl(Value >> 4)
        b = CDbl(CDbl(Value And &HF) * 0.0625)
        Return a + b
    End Function

End Class
